//********************************************************
//
//	CTDEV Header
//
//	Linux Driver for CT-3000 Series Frame_Grabber 
//

#define Driver_version	0x20001                   // ver 2.0.0

#include <linux/ioctl.h>

#define KERNEL_VER(major,minor,sublvl) (((major)<<16)+((minor)<<8)+(sublvl))

#define CT_MAJOR 88
#define CT_IOC_MAGIC 'k'
#define CT_VENDOR_ID 0x5558
#define CT_MEMORY_SIZE 0x200000
#define CT_DEVICE_TYPE 0x40000

// ioctl command

#define CT_IOCRESET     _IOWR(CT_IOC_MAGIC,0x00, 0)  //
#define CT_PHYSMEM_MMAP _IOWR(CT_IOC_MAGIC,0x01, 0)  // notice only
#define CT_FREEPHYSMEM  _IOWR(CT_IOC_MAGIC,0x02, 0)  // not used
#define CT_OUTDW        _IOWR(CT_IOC_MAGIC,0x03, 0)  // outl
#define CT_INDW         _IOWR(CT_IOC_MAGIC,0x04, 0)  // inl
#define CT_GETVERSION   _IOWR(CT_IOC_MAGIC,0x05, 0)  // get version
#define CT_GETDEVICEINF _IOWR(CT_IOC_MAGIC,0x06, 0)  // not used
#define CT_GETPCICONF   _IOWR(CT_IOC_MAGIC,0x07, 0)  // get pci config_data
#define CT_OUTW         _IOWR(CT_IOC_MAGIC,0x13, 0)  // outw
#define CT_INW          _IOWR(CT_IOC_MAGIC,0x14, 0)  // inw
#define CT_OUTB         _IOWR(CT_IOC_MAGIC,0x23, 0)  // outb
#define CT_INB          _IOWR(CT_IOC_MAGIC,0x24, 0)  // inb
#define CT_IOCHARDRESET _IOWR(CT_IOC_MAGIC,0x25, 0)  // (debug)

#define CT_IOC_MAXNR	0x25

typedef	unsigned char	UCHAR;
typedef	unsigned int	UINT;
typedef	unsigned long	ULONG;
typedef signed char	SCHAR;
typedef unsigned long	*PULONG;
typedef	unsigned char   *PUCHAR;

typedef struct {
  ULONG      PhyMemBase;
  ULONG      MemSize;
  ULONG      parm[4];
} DEVICE_TBL,*PDEVICE_TBL;



