//*************************************************
//
//	      "ctdev"
//	 driver I/F sample
//
//	 to make excutable "a.out" : gcc sampl.c
//
 
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <asm/mman.h>
#include <unistd.h>
#include "ct_ioctl.h"

main()
{
  int brd_id=0/*board_ID*/;
  int fhdl,rslt,tmpi,j;
  ULONG parm[4],i;
  PUCHAR mem;
  UINT Port_Base;   


  fhdl = open("/dev/ctdev",O_RDWR);
  if(fhdl == -1){
    printf("Open error \n");
    return;
  }
// get version
  rslt = ioctl(fhdl,CT_GETVERSION,parm);
  if(rslt){ printf("ioctl(CT_GETVERSION) error\n"); return;}
  else printf("version=%lx\n",parm[0]);

// get ioport_base from pci_cofiguration register
  parm[1] = 0x3000 /* Device_ID */; parm[2] = brd_id /* Board_ID */;
  parm[3] = 0x14 /* io_base_address */;
  rslt = ioctl(fhdl,CT_GETPCICONF,parm);
  Port_Base = (UINT)parm[0] & 0xfff0 /* io_address mask */;  
  if(rslt){ printf("ioctl(CT_GETPCICONF) error\n"); return;}
  else printf("rslt=%d  : ioport_base_address=%x\n",rslt,Port_Base);
  
// freeze board(outb)
  parm[1] = Port_Base; parm[2] = 0x11;
  rslt = ioctl(fhdl,CT_OUTB,parm);  
 
// wait under_writing=0
  parm[1] = Port_Base;
  for(i=0;i<200000;i++){
    rslt = ioctl(fhdl,CT_INB,parm);
    if(!(parm[0] & 0x1)) break;
  }	// avoid dead_lock if continuous bit = 1

// 60 field wait(1 sec,when RS-170A standard video signal supplied)
  parm[1] = Port_Base;
  for(j=0;j<60;j++){
    rslt = ioctl(fhdl,CT_INB,parm); tmpi = parm[0];
    for(i=0;i<200000;i++){
      rslt = ioctl(fhdl,CT_INB,parm);
      if((parm[0]^tmpi) & 0x80) break;	// frame_index chgd?
 
  }	// avoid dead_lock if non_interlace signal supplied
  }

 
// input
  parm[1] = Port_Base;
  rslt = ioctl(fhdl,CT_INB,parm);  
  printf("rslt=%d  : input=%x\n",rslt,(UCHAR)parm[0]);

// physical memory to mmap
  parm[1] = (ULONG)-1; parm[2] = 0x3000 /* Device_ID */;
  parm[3] = brd_id /* Board_ID */;
  rslt = ioctl(fhdl,CT_PHYSMEM_MMAP,parm);
  if(rslt){ printf("ioctl(CT_PHYSMEM_MMAP) error\n"); return;}
  else printf("rslt=%d  : phy_address=%lx\n",rslt,parm[0]);
  mem = (PUCHAR)mmap((caddr_t)0,0x200000l,PROT_READ | PROT_WRITE,MAP_SHARED,fhdl,0);
  printf("Virtual_address=%lx\n",(ULONG)mem);  

// clear memory
  for(i=0;i<0x80000;i++) mem[i]=0;

  munmap(mem,0x200000l);	// unmap mmaped memory
  close(fhdl);
}

